<?php

/*
	[DIY-Page] (C) DIY Innovation Inc.
	$Id: func.php 263 2010-10-25 11:00:36Z wenshuang $
*/

function file_fetch($fileid) {
	if (function_exists('file_get_contents')) return file_get_contents($fileid);

	$retry=100;
	for ($i=0;$i<$retry;$i++) {
		$ft=fopen($fileid,"rb");
		if ($ft!==false) break;
		if ($i==($retry-1)) return false;
	}
	$filecontent='';
	while (!feof($ft)) {
		$filecontent.=fread($ft,4096);
	}
	fclose($ft);
	return $filecontent;
}

function file_write($fileid,$filecontent,$mode='wb') {
	$retry=100;
	for ($i=0;$i<$retry;$i++) {
		$ft=fopen($fileid,$mode);
		if ($ft!==false) break;
		if ($i==($retry-1)) return false;
	}
	flock($ft,LOCK_UN);
	flock($ft,LOCK_EX|LOCK_NB);
	for ($i=0;$i<$retry;$i++) {
		$tmp=fwrite($ft,$filecontent);
		if ($tmp!==false) break;
		if ($i==($retry-1)) return false;
	}
	flock($ft,LOCK_UN);
	fclose($ft);
	chmod($fileid,0777);
	return true;
}

function dpfetchdata($dataname) {
	include PATH_PRE.'data/'.$dataname.'.php';
	$sarray=array('adminsession','foresession','spidersession');
	if (in_array($dataname,$sarray)) {
		$dataarray=stripslashes($dataarray);
		$dataarray=mb_unserialize($dataarray);
	}
	return $dataarray;
}

function dpwritedata($dataname,$dataarray) {
	$datafile=PATH_PRE.'data/'.$dataname.'.php';
	$sarray=array('adminsession','foresession','spidersession');
	if (in_array($dataname,$sarray)) {
		$dataarray=serialize($dataarray);
		$dataarray=addslashes($dataarray);
		$datacontent="<?php\r\n".'$dataarray=\''.$dataarray.'\';'."\r\n?>";
	}else{
		$datacontent="<?php\r\n".'$dataarray='.var_export($dataarray,true).';'."\r\n?>";
	}
	return file_write($datafile,$datacontent);
}

function dpfetchsession($dataname) {
	$dataarray=file_fetch(PATH_PRE.'data/'.$dataname.'.txt');
	$dataarray=mb_unserialize($dataarray);
	if ($dataarray===false) $dataarray=array('none'=>'none');
	return $dataarray;
}

function dpwritesession($dataname,$dataarray) {
	$datafile=PATH_PRE.'data/'.$dataname.'.txt';
	$dataarray=serialize($dataarray);
	return file_write($datafile,$dataarray);
}

function dpwrite_basicset() {
	global $d_basicset;
	$datafile=PATH_PRE.'data/basicset.php';
	$datacontent="<?php\r\n".'$d_basicset='.var_export($d_basicset,true).';'."\r\n?>";
	return file_write($datafile,$datacontent);
}

function dpwrite_config_dp() {
	global $dbhost,$dbuser,$dbpassword,$dbname,$dbcharset;
	$datafile=PATH_PRE.'config.php';
	$datacontent='<?php
	$dbhost="'.$dbhost.'";
	$dbuser="'.$dbuser.'";
	$dbpassword="'.$dbpassword.'";
	$dbname="'.$dbname.'";
	$dbcharset="'.$dbcharset.'";
?>';
	return file_write($datafile,$datacontent);
}

function gethead($type) {
	global $d_mainset,$d_basicset,$l_error;
	$a=array();

	$incfile=PATH_PRE.'lang/'.$d_basicset['langpak'].'/fore.php';
	if (!include $incfile) dperror($l_error['adminlang'],$incfile,true);
	if (b64($d_mainset['sitename'])=='')
	$d_mainset['sitename']=b64($l_fore['default_sitename'],true);
	if (b64($d_mainset['maintitle'])=='') $d_mainset['maintitle']=b64($l_fore['default_maintitle'],true);
	if (b64($d_mainset['titleextra'])=='') $d_mainset['titleextra']=b64($l_fore['default_titleextra'],true);
	if (b64($d_mainset['keywords'])=='') $d_mainset['keywords']=b64($l_fore['default_keywords'],true);
	if (b64($d_mainset['description'])=='') $d_mainset['description']=b64($l_fore['default_description'],true);

	$path=explode('/',$_SERVER['PHP_SELF']);
	if ($path[(count($path)-1)]!='index.php') $path[(count($path)-1)]='index.php';
	$path=implode('/',$path);
	$path=substr($path,0,strpos($path,'index.php'));
	$a['baseurl']='http://'.$_SERVER['HTTP_HOST'].$path;

	$a['maintitle']=b64($d_mainset['maintitle']);
	$a['titleextra']=trim(b64($d_mainset['titleextra']))!='' ? '_'.b64($d_mainset['titleextra']) : '';
	include PATH_PRE.'id/'.$type.'_title.php';
	$a['titlemain']=$titlemain;

	$var=$titlemain;
	$main=b64($d_mainset['maintitle']);
	$extra=b64($d_mainset['titleextra']);
	if (b64($d_mainset['titlecustom'])) {
		$lines=explode("\n",str_replace("\r",'',b64($d_mainset['titlecustom'])));
		foreach ($lines as $cur) {
			$half=explode('{=}',$cur);
			if ($half[0]==$_GET['pagetype']) {
				$var=rtrim($titlemain,'_');
				eval('$a["pagetitle"]="'.$half[1].'";');
			}
		}
	}
	if (!$a['pagetitle']) $a['pagetitle']=$var.$main.'_'.$extra;

	$a['sitename']=b64($d_mainset['sitename']);
	$a['keywords']=b64($d_mainset['keywords']);
	$a['description']=b64($d_mainset['description']);
	$a['generator']='DIY-Page '.DP_VERSION.' Build '.DP_RELEASE;
	return $a;
}

function output_replace($output) {
	global $d_basicset,$d_mainset;
	$output=preg_replace('/ dpid="[a-z0-9]*"/','',$output);
	$output=preg_replace('/<\!--begin:[a-z0-9:]+-->/','',$output);
	$output=preg_replace('/<\!--end:[a-z0-9:]+-->/','',$output);
	$output=preg_replace('/<\/body>/i',dplicenser().($d_mainset['mod_setting']['spider']['autospider'] ? '' : '<img src="spider.php" style="display:none" border="0" width="1" height="1" />').'</body>',$output);
	$output=str_replace(array("\t","\r"),'',$output);

	if ($d_basicset['wwwrootpath']) $output=str_replace(array('"img/','tpl/'),array('"'.$d_basicset['wwwrootpath'].'img/',$d_basicset['wwwrootpath'].'tpl/'),$output);

	return censor_replace($output);
}

function gethtmllinkformat($type,$ispage=false,$date=false) {
	global $d_basicset;
	$format=$d_basicset['htmldir'];
	$ext= trim($d_basicset['html_file_ext'])!='' ? $d_basicset['html_file_ext'] : 'htm';
	$format.= $date ? '/%s' : '';
	$format.= '/'.str_replace($d_basicset['urlptnames_from'],$d_basicset['urlptnames_to'],$type).'-%s';
	$format.= $ispage ? '-%s' : '';
	$format.= '.'.$ext;
	return $format;
}

function getdpcmslink($type,$dir,$rule,$val,$index=1) {
	if ($type=='list') {
		$srch=array('{cataid}','{page}');
	} else if ($type=='entry') {
		$srch=array('{y}','{m}','{d}','{eid}');
		list($y,$m,$d)=explode('-',date('Y-m-d',$val[0]));
		$val=array($y,$m,$d,$val[1]);
	}
	$file=$dir.'/'.str_replace($srch,$val,$rule);
	if ($index) {
		$tmp=explode('/',$file);
		if (substr($tmp[count($tmp)-1],0,6)=='index.') {
			array_pop($tmp);
			$file=implode('/',$tmp);
		}
	}
	return $file;
}

function mkhtmldir($file,$r=false) {
	$farr=explode('/',$file);
	array_pop($farr);
	$dir=$coma='';
	foreach ($farr as $cf) {
		$dir.=$coma.$cf;
		$coma='/';
		if (!is_dir(PATH_PRE.$dir)) {
			mkdir($dir,0777);
		}
	}
	if($r) return $dir;
}

function dperror($errortext='',$errordetail='',$ifreport=false) {
	if ($ifreport) {
		global $d_basicset,$l_error;
		if (trim($errortext)=='') $errortext=$l_error['unknown'];
		$errordetailstr= trim($errordetail)!='' ? '<br /><br />'.str_replace(PATH_PRE,'',$errordetail) : '';
		$gobackstr= trim($_SERVER['HTTP_REFERER'])!='' ? '<br /><br /><a href="'.$_SERVER['HTTP_REFERER'].'">'.$l_error['goback'].'</a>' : '';
		$helpstr='<br /><br />'.(file_exists(PATH_PRE.'inc/vip0.php') ? $l_error['get_help_vip'] : $l_error['get_help_free']);
		echo '<html><head><title>'.$l_error['errortitle'].'</title><meta http-equiv="Content-Type" content="text/html; charset='.$d_basicset['langpak'].'"></head><body style="font-size: 16px;"><div style="font-size: 24px; font-weight: bold;">'.$l_error['errortitle'].'</div><hr /><blockquote>'.$errortext.$errordetailstr.$gobackstr.$helpstr.'</blockquote><hr /><div align="center">&#169;&#160;DIY-Page&#160;'.DP_VERSION.'&#160;Build&#160;'.DP_RELEASE.'</div></body></html>';
	}
	exit();
}

function getuserip() {
	if (getenv('HTTP_CLIENT_IP') and strcasecmp(getenv('HTTP_CLIENT_IP'),'unknown')) {
		$onlineip=getenv('HTTP_CLIENT_IP');
	}elseif (getenv('HTTP_X_FORWARDED_FOR') and strcasecmp(getenv('HTTP_X_FORWARDED_FOR'),'unknown')) {
		$onlineip=getenv('HTTP_X_FORWARDED_FOR');
	}elseif (getenv('REMOTE_ADDR') and strcasecmp(getenv('REMOTE_ADDR'),'unknown')) {
		$onlineip=getenv('REMOTE_ADDR');
	}elseif (isset($_SERVER['REMOTE_ADDR']) and $_SERVER['REMOTE_ADDR'] and strcasecmp($_SERVER['REMOTE_ADDR'],'unknown')) {
		$onlineip=$_SERVER['REMOTE_ADDR'];
	}
	return preg_replace("/^([\d\.]+).*/","\\1",$onlineip);
}

function ur1decode($string,$isencode=false,$key=''){ return $string; }

function color_array() {
	return array(
		'BrightRed'=>'#FF3300',
		'BrightOrange'=>'#FFA500',
		'BrightGreen'=>'#32CD32',
		'MiddleBlue'=>'#6495ED',
		'Purple'=>'#9933CC',
		'LightPurple'=>'#0B54B7',
		'ShinySilver'=>'#EEEEEE',
		'RedditWhite'=>'#FFFFFF',
		'Magnolia'=>'#F9F7ED',
		'ActionYellow'=>'#FFFF88',
		'QoopMint'=>'#CDEB8B',
		'GmailBlue'=>'#C3D9FF',
		'ShadowsGrey'=>'#36393D',
		'MozillaRed'=>'#FF1A00',
		'RollyoRed'=>'#CC0000',
		'RSSOrange'=>'#FF7400',
		'TechcrunchGreen'=>'#008C00',
		'NewsvineGreen'=>'#006E2E',
		'FlockBlue'=>'#4096EE',
		'FlickrPink'=>'#FF0084',
		'RubyOnRailsRed'=>'#B02B2C',
		'EtsyVermillion'=>'#D15600',
		'ThingsGold'=>'#C79810',
		'WritelyOlive'=>'#73880A',
		'BasecampGreen'=>'#6BBA70',
		'MozillaBlue'=>'#3F4C6B',
		'DiggBlue'=>'#356AA0',
		'LastCrimson'=>'#D01F3C'
	);
}

function color_selector($textboxname,$curvalue='',$coloroffset=null,$objlength=null,$selectonly=false) {
	$colorarray=color_array();
	$htmlcode='<select name="'.($selectonly ? $textboxname : 'colorselector').'"'.($selectonly==false ? ' onchange="if(this.options[this.selectedIndex].value) {'.$textboxname.'.value=this.options[this.selectedIndex].value;}" size="1"' : '').'>';
	foreach ($colorarray as $key => $val) {
		$isselected= $val==$curvalue ? " selected" : "";
		$htmlcode.='<option value="'.$val.'" style="background-color:'.$val.'"'.$isselected.'>'.$key.'</option>';
	}
	$htmlcode.='</select>';
	return $htmlcode;
}

function cutstr($string,$length,$dot='...',$start=0) {
	global $charset;
	$string=str_replace(array('&amp;','&quot;','&lt;','&gt;','&nbsp;','&#160;'),array('&','"','<','>',' ',' '),$string);
	if (strlen($string)<=$length) return $string;
	$strcut='';
	if (strtolower($charset)=='utf-8') {
		$n=$tn=$noc=0;
		while ($n<strlen($string)) {
			$t=ord($string[$n]);
			if ($t==9 || $t==10 || (32<=$t && $t<=126)) {
				$tn=1;
				$n++;
				$noc++;
			}elseif (194<=$t && $t<=223) {
				$tn=2;
				$n+=2;
				$noc+=2;
			}elseif (224<=$t && $t<239) {
				$tn=3;
				$n+=3;
				$noc+=2;
			}elseif (240<=$t && $t<=247) {
				$tn=4;
				$n+=4;
				$noc+=2;
			}elseif (248<=$t && $t<=251) {
				$tn=5;
				$n+=5;
				$noc+=2;
			}elseif ($t==252 || $t==253) {
				$tn=6;
				$n+=6;
				$noc+=2;
			}else{
				$n++;
			}
			if ($noc>=$length) break;
		}
		if ($noc>$length) $n-=$tn;
		$strcut=substr($string,$start,$n);
	}else{
		for ($i=$start;$i<$start+$length-strlen($dot)-1;$i++) {
			$strcut.=ord($string[$i])>127 ? $string[$i].$string[++$i] : $string[$i];
		}
	}
	return $strcut.$dot;
}

function b64($str,$encode=false) {
	if ($encode) {
		return '[b64]'.base64_encode($str);
	}else{
		if (substr($str,0,5)=='{b64}' or substr($str,0,5)=='[b64]') {
			return base64_decode(str_replace(array('{b64}','[b64]'),'',$str));
		}else{
			return $str;
		}
	}
}

function tovalname($str) {
	$find=array(' ','>','<','=','"',"'",'.');
	$replace=array('_SPACE_','_MORE_','_LESS_','_EQUAL_','_QUOTE_','_SQUOTE_','_DOT_');
	$str=str_replace($find,$replace,$str);
	return $str;
}

function num2img($numstr,$imgnum=7) {
	global $d_mainset;
	$returnstr='';
	$numlen=strlen($numstr);
	for ($i=0;$i<($imgnum-$numlen);$i++) {
		$returnstr.='<img src="tpl/'.$d_mainset['curstyle'].'/img/num/0.gif" border="0" width="9" height="13" />';
	}
	for ($i=0;$i<$numlen;$i++) {
		$curstr=substr($numstr,$i,1);
		$allows=array('1','2','3','4','5','6','7','8','9','0');
		if (in_array($curstr,$allows)) $returnstr.='<img src="tpl/'.$d_mainset['curstyle'].'/img/num/'.$curstr.'.gif" border="0" width="9" height="13" />';
	}
	return $returnstr;
}

function remove_extra_url_para($qstr0,$todel) {
	$arr0=explode('?',$qstr0);
	if (trim($arr0[1])!='') {
		$arr=explode('&',$arr0[1]);
		for ($i=0;$i<count($arr);$i++) {
			if (strstr($arr[$i],$todel)) array_splice($arr,$i,1);
		}
		$uri=implode('&',$arr);
		if (trim($uri)!='') $uri='?'.$uri;
		return $arr0[0].$uri;
	}
	return $qstr0;
}

function simple_size($filesize) {
	if($filesize>=1073741824) {
		$filesize=(round($filesize/1073741824*100)/100).'&#160;GB';
	}elseif ($filesize>=1048576) {
		$filesize=(round($filesize/1048576*100)/100).'&#160;MB';
	}elseif ($filesize>=1024) {
		$filesize=(round($filesize/1024*100)/100).'&#160;KB';
	}else{
		$filesize=$filesize.'&#160;B';
	}
	return $filesize;
}

function simple_time($sec,$lang) {
	if (!$sec) return '0 '.$lang['sec'];
	$str='';
	if ($sec>=86400) {
		$day=floor($sec/86400);
		$sec-=$day*86400;
		$str.=$day.' '.$lang['day'].' ';
	}
	if ($sec>=3600) {
		$hour=floor($sec/3600);
		$sec-=$hour*3600;
		$str.=$hour.' '.$lang['hour'].' ';
	}
	if ($sec>=60) {
		$min=floor($sec/60);
		$sec-=$min*60;
		$str.=$min.' '.$lang['min'].' ';
	}
	if ($sec>0) $str.=$sec.' '.$lang['sec'];
	$str=rtrim($str);
	return $str;
}

function filelistjsstr($isparent=false) {
	global $l_editor,$d_mainset,$actionurl,$d_basicset;
	include_once PATH_PRE.'lang/'.$d_basicset['langpak'].'/texteditor.php';
	$jsstr='';
	$query=db_query('SELECT fid,realname,filename,filetype,filesize,builddate FROM '.$d_basicset['dbprefix'].'cms_file WHERE eid='.$_GET['eid'].' AND builddate>'.(time()-1800).' ORDER BY fid DESC LIMIT 100');
	if (db_num_rows($query)>0) {
		while ($rec=db_fetch_array($query)) {
			$jsstr.='<img style="margin:8px 2px 0 0" border="0" src="img/dpcms/';
			if (substr($rec['filetype'],0,5)=='image') {
				$jsstr.='file_image.gif';
			}else{
				$jsstr.='file_other.gif';
			}
			$jsstr.='" /><a href="javascript:;" title="'.$l_editor['upload_it'].'&#160;&#160;'.simple_size($rec['filesize']).'&#160;&#160;'.date($d_mainset['mod_setting']['dpcms']['dateformat'],$rec['builddate']).'" onclick="insert_file(\''.$rec['fid'].'\');">'.$rec['realname'].'</a><img border="0" src="img/dpcms/file_delete.gif" alt="'.$l_editor['upload_del'].'" style="cursor:hand;" onclick="if(confirm(\''.$l_editor['upload_del_ensure'].'\'))deleteaction.location=\''.$actionurl.'&do=deletefile&fid='.$rec['fid'].'&eid='.$_GET['eid'].'\';" />&#160;&#160;&#160;';
		}
	}else{
		$jsstr.=$l_editor['upload_nofile'];
	}
	return ($isparent ? 'parent.parent.' : '').'entryfilelist.innerHTML="'.addslashes($jsstr).'";';
}

function insertfilejsfunc() {
	$jsstr=<<<HTML
function insert_file(fid) {
	parent.parent.EditCtrl.focus();
	edit=parent.parent.EditCtrl.document.selection.createRange();
	edit.pasteHTML('{file:'+fid+'}');
	edit.select();
	parent.parent.EditCtrl.focus();
}
HTML;
	return $jsstr;
}

function process_file($fid,$w) {
	global $d_basicset,$iswap;
	$rec=db_fetch_array(db_query('SELECT * FROM '.$d_basicset['dbprefix'].'cms_file WHERE fid='.intval($fid)));
	if (substr($rec['filetype'],0,5)=='image') {
		$picurl=rawurlencode(get_upload_path(true).'/'.$rec['filename']);
		return '<div style="margin:5px" align="center">'.($iswap ? '<a href="js.php?mod=dpcms&name=url&url='.$picurl.'">' : '').'<img border="0" src="thumb.php?w='.$w.'&url='.$picurl.'" alt="'.$rec['realname'].'" />'.($iswap ? '</a>' : '').'</div>';
	}else{
		return '<div style="margin:5px" align="center"><img border="0" src="img/downfile.gif" />&#160;<a href="file.php?fid='.intval($fid).'">'.$rec['realname'].'</a></div>';
	}
}

function parsetags($tags) {
	global $d_basicset;
	if (empty($tags)) return '';
	$tidarr=array();
	$tags=explode(' ',$tags);
	foreach ($tags as $tag) {
		if (!empty($tag)) {
			$tid=db_result(db_query('SELECT tid FROM '.$d_basicset['dbprefix'].'cms_tags WHERE tagname="'.$tag.'"'));
			if ($tid) {
				$tidarr[]=$tid;
				db_query('UPDATE '.$d_basicset['dbprefix'].'cms_tags SET num=num+1 WHERE tid='.$tid);
			}else{
				db_query('INSERT INTO '.$d_basicset['dbprefix'].'cms_tags(tagname,num) VALUES("'.$tag.'",1)');
				$tidarr[]=db_insert_id();
			}
		}
	}
	return implode(',',$tidarr);
}

function update_tag_cache() {
	global $d_basicset,$sessionarray;
	$query=db_query('SELECT tid,tagname FROM '.$d_basicset['dbprefix'].'cms_tags');
	$tagsarr=array();
	while ($rec=db_fetch_array($query)) {
		$tagsarr[$rec['tid']]=$rec['tagname'];
	}
	$sessionarray['tagarray']=$tagsarr;
	dpwritesession('adminsession',$sessionarray);
	return $sessionarray['tagarray'];
}

function update_keyword_cache() {
	global $d_basicset,$sessionarray;
	$query=db_query('SELECT kword,kurl,klimit FROM '.$d_basicset['dbprefix'].'cms_keyword WHERE active=1');
	$keywordarr=array();
	while ($rec=db_fetch_array($query)) {
		$keywordarr[]=$rec;
	}
	$sessionarray['keywordarray']=$keywordarr;
	dpwritesession('adminsession',$sessionarray);
	return $sessionarray['keywordarray'];
}

function getoptionarr($optstr) {
	$optstr=str_replace("\r",'',$optstr);
	$optarr=explode("\n",$optstr);
	$r=array();
	$i=0;
	foreach ($optarr as $k=>$val) {
		if (!empty($val)) {
			if ($k%2==0) {
				$tmp=explode('!',$val);
				if (isset($tmp[1])) {
					$r['def'][]=$tmp[1];
					$r['opt'][$i]['key']=$tmp[1];
				}else{
					$r['opt'][$i]['key']=$val;
				}
			}else{
				$r['opt'][$i]['val']=$val;
				$i++;
			}
		}
	}
	return $r;
}

function pageurl($offset=5){
	global $l_admin,$pageurl,$total_num,$maxpage,$page;
	$str='';

	if($page>1){
		$str.='<a href="'.$pageurl.'">'.$l_admin['page_home'].'</a>';
		$str.='<a href="'.$pageurl.'&page='.($page-1).'">'.$l_admin['page_pvev'].'</a>';
	}

	$i= $page>$offset ? $page-$offset : 1 ;
	$i_end= ($page+$offset)>$maxpage ? $maxpage  : ($page+$offset<$offset*2 ? $offset*2 :$page+$offset-1) ;

	for($i;$i<=$i_end;$i++){
		if($page==$i) $str.='<b>'.$i.'</b>';
		else $str.='<a href="'.$pageurl.'&page='.$i.'">'.$i.'</a>';
	}
	
	if($page<$maxpage){
		$str.='<a href="'.$pageurl.'&page='.($page+1).'">'.$l_admin['page_next'].'</a>';
		$str.='<a href="'.$pageurl.'&page='.$maxpage.'">'.$l_admin['page_end'].'</a>';
	}
	return $str;
}

function censor_replace($str,$default='***'){
	$censor_con=file_fetch(PATH_PRE.'data/censor.txt');
	$a2=explode("\n",str_replace("\r",'',trim($censor_con)));

	$search=$replace=array();
	foreach($a2 as $v){
		$s2=explode('=',$v);
		$search[]=$s2[0];
		$replace[]=empty($s2[1]) ? $default : $s2[1];
	}
	return str_replace($search,$replace,$str);
}

function mb_unserialize($serial_str) {
	$out=preg_replace('!s:(\d+):"(.*?)";!se',"'s:'.strlen('$2').':\"$2\";'",$serial_str);
	return unserialize($out);
}

function foremsg($msg,$backurl='',$backtime='3000') {
	global $l_fore,$d_mainset,$charset;
	if (!$backurl) $backurl= $_SERVER['HTTP_REFERER'] ? $_SERVER['HTTP_REFERER'] : './';
	$incfile=PATH_PRE.'inc/tpl.php';
	if (!include_once $incfile) dperror($l_error['cant_include'],$incfile,true);
	ob_start();
	$incfile=dp_tpl(PATH_PRE.'tpl/'.$d_mainset['curstyle'].'/foremsg.htm');
	if (!include $incfile) dperror($l_error['cant_include'],$incfile,true);
	$pagebody=ob_get_contents();
	ob_end_clean();
	exit(output_replace($pagebody));
}

function get_upload_path($isfore=false) {
	global $d_basicset;
	$str=$d_basicset['uploadpath'];
	if (!$isfore and substr($str,0,7)!='http://' and substr($str,0,6)!='ftp://') $str=PATH_PRE.$str;
	return $str;
}

function get_upload_filename($realname) {
	$exttmp=explode(".",$realname);
	$ext=$exttmp[count($exttmp)-1];
	$filepath=get_upload_path().'/';
	$filesubdir=date('Ym').'/';
	mkdir($filepath.$filesubdir,0777);
	$datetmp=explode(" ",microtime());
	$filesuffix=substr(md5($datetmp[1]),0,6);
	if(!in_array(strtolower($ext),array('jpg','gif','png','bmp'))) $ext.='.file';
	$filename=$filesubdir.date('Ymd').'_'.md5($realname).'_'.$filesuffix.'.'.$ext;
	$filepath.=$filename;
	return array('filename'=>$filename,'filepath'=>$filepath);
}

function html_closetag($str) {
	preg_match_all('/<[^>]+>/',$str,$matches,PREG_SET_ORDER);
	$tagcount=array();
	foreach ($matches as $cur) {
		$parts=explode(' ',$cur[0]);
		$tagname=strtolower(rtrim(ltrim($parts[0],'<'),'>'));
		$tagrealname=ltrim($tagname,'/');
		$tagcount[$tagrealname]=intval($tagcount[$tagrealname]);
		if (substr($tagname,0,1)=='/') {
			$tagcount[$tagrealname]--;
		}else{
			$tagcount[$tagrealname]++;
		}
	}
	$noarr=array('base','link','meta','br','hr','img','input','param');
	foreach ($tagcount as $key => $val) {
		if (!in_array(strtolower($key),$noarr)) {
			if ($val<0) {
				$str=str_repeat('<'.$key.'>',abs($val)).$str;
			}elseif ($val>0) {
				$str.=str_repeat('</'.$key.'>',$val);
			}
		}
	}
	return $str;
}

function spider_fetch($url) {
	$contents='';
	if (function_exists('curl_init')) {
		$ch=curl_init();
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,10);
		curl_setopt($ch,CURLOPT_FOLLOWLOCATION,1);
		$contents=trim(curl_exec($ch));
		curl_close($ch);
		return $contents;
	}else{
		include_once PATH_PRE.'inc/snoopy.class.php';
		$snoopy=new Snoopy();
		$snoopy->read_timeout=10;
		$snoopy->fetch($url);
		$contents=$snoopy->results;
		if (!$contents) $contents=file_get_contents($url);
		return $contents;
	}
}

function lsort($a,$b) {
	if (strlen($a)==strlen($b)) return 0;
	return strlen($a)>strlen($b) ? 1 : -1;
}

function get_max_key($arr) {
	$indexarr=array_keys($arr);
	rsort($indexarr);
	return $indexarr[0];
}

function get_domain($str) {
	preg_match('/[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+\.?/',$str,$matches);
	return $matches[0];
}

function order_sort($a,$b) {
	if ($a['order']==$b['order']) return 0;
	return $a['order']>$b['order'] ? 1 : -1;
}
?>