<?php

/*
	[DIY-Page] (C) DIY Innovation Inc.
	$Id: rss.php 45 2010-04-21 01:36:07Z wenshuang $
*/

error_reporting(0);

define('PATH_PRE',str_replace('\\','/',dirname(__FILE__)).'/');

$PHP_SELF= $_SERVER['PHP_SELF'] ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME'];
$boardurl='http://'.$_SERVER['HTTP_HOST'].substr($PHP_SELF, 0, strrpos($PHP_SELF, '/') + 1);

if (PHP_VERSION<'4.1.0') {
	$_GET=&$HTTP_GET_VARS;
	$_POST=&$HTTP_POST_VARS;
	$_COOKIE=&$HTTP_COOKIE_VARS;
	$_SERVER=&$HTTP_SERVER_VARS;
	$_ENV=&$HTTP_ENV_VARS;
	$_FILES=&$HTTP_POST_FILES;
}

if (!include PATH_PRE.'ver.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to read version information.<br />File: ./ver.php');

if (!include PATH_PRE.'inc/func.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to initiate kernel functions.<br />File: ./inc/func.php');
if (!include PATH_PRE.'inc/db.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to initiate database functions.<br />File: ./inc/db.php');
if (!include PATH_PRE.'inc/secure_getpost.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to initiate security module.<br />File: ./inc/secure_getpost.php');
if (!include PATH_PRE.'inc/pagecache.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to initiate cache functions.<br />File: ./inc/pagecache.php');

if (!include PATH_PRE.'data/basicset.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to fetch basic settings.<br />File: ./data/basicset.php');

if (!include PATH_PRE.'config.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to fetch basic settings.<br />File: ./config.php');

if (!include PATH_PRE.'lang/'.$d_basicset['langpak'].'/error.php') exit('<b>DIY-Page Kernel Error:</b><br />Failed to initiate language characters of error messages.<br />File: ./lang/'.$d_basicset['langpak'].'/error.php');

$d_mainset=dpfetchdata('mainset');
if (empty($d_mainset)) dperror($l_error['cant_fetchdata'],'mainset',true);

$timeoffset=intval($d_mainset['timezone']);
if (PHP_VERSION>'5.1') date_default_timezone_set('Etc/GMT'.($timeoffset > 0 ? '-' : '+').(abs($timeoffset)));


$incfile=PATH_PRE.'lang/'.$d_basicset['langpak'].'/index.php';
if (!include $incfile) dperror($l_error['adminlang'],$incfile,true);
$charset=$intro_lang['charset'];

if (!$d_basicset['rss']['open']) exit();

if (db_connect(ur1decode($dbhost),ur1decode($dbuser),ur1decode($dbpassword),$dbcharset)==false) dperror($l_error['dbconnect'],db_errno().' '.db_error(),true);
if (db_selectdb(ur1decode($dbname))==false) dperror($l_error['dbselect'],db_errno().' '.db_error(),true);

header("Content-type: application/xml");

$cachedir=PATH_PRE.'temp/page';
if (!is_dir($cachedir)) mkdir($cachedir,0777);
$cacheid=$cachedir.'/dprss.htm';
if (cache_isvalid($cacheid,$d_basicset['rss']['cachetime'])) {
	$totaloutput=file_fetch($cacheid);
	if ($d_basicset['gzip']) ob_start("ob_gzhandler");
	echo $totaloutput;
	exit();
}

$maparr=array();
foreach ($d_basicset['rss']['class'] as $mod=>$idarr) {
	include PATH_PRE.'id/'.$mod.'_rss.php';
	$maparr=array_merge($maparr,$listarr);
}

usort($maparr,'cmp');
$maxnum= intval($d_basicset['rss']['maxnum'])<0 ? 10 : intval($d_basicset['rss']['maxnum']);
$maparr=array_slice($maparr,0,$maxnum);


$output="<?xml version=\"1.0\" encoding=\"$charset\"?>\n<rss version=\"2.0\">\n<channel>\n";
$output.="<title>".b64($d_mainset['sitename'])."</title>\n";
$output.="<link>$boardurl</link>\n<description>".b64($d_mainset['description'])."</description>\n<language>zh-cn</language>\n";
$output.="<generator>DIY-Page ".DP_VERSION."</generator>\n";

foreach ($maparr as $map) {
	$output.="<item>\n".
		"<link><![CDATA[".$boardurl.$map['url']."]]></link>\n".
		"<title><![CDATA[".htmlspecialchars($map['title'])."]]></title>\n".
		"<pubDate>".date('c',$map['date'])."</pubDate>\n".
        "<author><![CDATA[".$map['author']."]]></author>\n".
        "<description><![CDATA[".$map['desc']."]]></description>\n".
		"</item>\n";
}
$output.="</channel>\n</rss>";

if ($d_basicset['rss']['cachetime']) {
	if (!file_write($cacheid,$output)) dperror($l_error['cant_writedata'],$cacheid,true);
}
if ($d_basicset['gzip']) ob_start("ob_gzhandler");
echo $output;

function cmp($a, $b) {
    if ($a['date']==$b['date']) return 0;
    return ($a['date'] > $b['date']) ? -1 : 1;
}
?>